function push(t,v) table.insert(t,v) end
function pop(t) return table.remove(t) end
function len(t) return #t end
function shift(t) return table.remove(t,1) end
function pick(v,a,b) if v then return a end return b end
function bool(v) return not not v end
min = math.min
max = math.max
abs = math.abs
function round(v) return math.floor(v + 0.5) end
function sign(v) if v > 0 then return 1 end if v < 0 then return -1 end return 0 end

function class(name,base)
    if global ~= nil then global(name) end
    _ENV[name] = _ENV[name] or {}
    local klass = _ENV[name]
    if base ~= nil then for k,v in pairs(base) do klass[k] = v end end
    klass.__index = klass
    local meta = {}
    function meta:__call(...)
        local obj = {}
        setmetatable(obj,klass)
        obj:init(...)
        return obj
    end
    setmetatable(klass,meta)
end

function deepcopy(o)
    if type(o) ~= 'table' then return o end
    local r = {}
    for k,v in pairs(o) do r[k] = deepcopy(v) end
    return r
end

